            #GIT_CMT=4c98123f6080dadb15bdade78a6b34829313a7e5
%define pname oracle-database-preinstall
%define dbrel 19c
%define configdir /etc/sysconfig
%define logdir /var/log
%define version 1.0
%define release 1%{?dist}
%define name %{pname}-%{dbrel}
%global debug_package %{nil}

Summary: "Sets the system for Oracle Database single instance and Real Application Cluster %{dbrel} install for Oracle Linux %{?dist}"
Name: %{name}
Version: %{version}
Release:    1.el8
Group: Test Environment/Libraries
License: GPLv2
Vendor: Oracle
Source: oracle-database-preinstall-1.0.tar.bz2
Provides: %{name} = %{version}

Conflicts: exadata-base
Requires(pre): /etc/redhat-release 
Requires: procps module-init-tools ethtool initscripts bind-utils nfs-utils util-linux-ng pam 
Requires: xorg-x11-utils xorg-x11-xauth smartmontools 
Requires: binutils glibc glibc-devel 
Requires: ksh libaio libaio-devel libgcc libstdc++ libstdc++-devel 
Requires: make sysstat openssh-clients 
Requires: psmisc net-tools unzip bc tar 
%if 0%{?el7} 
Requires: compat-libcap1 
%endif 
%if 0%{?el8} 
Requires: libnsl openssl-libs
%endif  

BuildRequires: bash
BuildRoot: %{_builddir}/%{pname}-%{version}-root

%description
"The Oracle Preinstallation RPM package installs software packages and sets system parameters required for Oracle Database single instance and Oracle Real Application Clusters %{dbrel} installations for Oracle Linux %{?dist}"
Files affected: /etc/sysctl.conf, /boot/grub/menu.lst OR /boot/grub2/grub.cfg OR /boot/efi/EFI/redhat/grub.cfg
Files added: /etc/security/limits.d/%{name}.conf

%prep
%setup -q -n %{pname}-%{version}

%build

%install 
mkdir -p -m 755 $RPM_BUILD_ROOT/usr/bin
mkdir -p -m 755 $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p -m 755 $RPM_BUILD_ROOT/etc/security/limits.d
mkdir -p -m 755 $RPM_BUILD_ROOT/%{configdir}/%{name}
mkdir -p -m 700 $RPM_BUILD_ROOT/%{logdir}/%{name}/results
install -m 700 %{pname}-verify $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}-verify
install -m 700 %{pname}-verify $RPM_BUILD_ROOT/usr/bin/%{name}-verify 
install -m 600 %{pname}.param $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}.param
install -m 700 %{pname}-firstboot $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}-firstboot
touch $RPM_BUILD_ROOT/etc/security/limits.d/%{name}.conf
ln -f -s %{configdir}/%{name}/%{name}-verify $RPM_BUILD_ROOT/usr/bin/%{name}-verify 
sed -i s/%{pname}/%{name}/g $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}-firstboot
sed -i s/%{pname}/%{name}/g $RPM_BUILD_ROOT/%{configdir}/%{name}/%{name}.param

%clean 
rm -rf $RPM_BUILD_ROOT

%define prescript()  \
if [ -f %{configdir}/%{pname}-%1/%{pname}-%1.param ]; then  \
  cp -f %{configdir}/%{pname}-%1/%{pname}-%1.param %{logdir}/%{pname}-%1/results/.%{pname}-%1.param; \
fi; \
if [ -d %{configdir}/%{pname}-%1 ]; then \
  rm -rf %{configdir}/%{pname}-%1; \
fi;  

%define preunscript()  \
if [ "$1" = "0" ] ; then \
 chkconfig --del %{pname}-%1-firstboot; \
 if [ -x /usr/bin/%{pname}-%1-verify ]; then \
   /usr/bin/%{pname}-%1-verify -u 2> /dev/null 1>&2; \
 fi; \
fi;  

%define posttransscript()  \
/usr/bin/%{pname}-%1-verify 2>/dev/null 1>&2; \
if ! [ -f %{configdir}/%{pname}-%1/%{pname}-%1.conf ]; then \
        chkconfig --add %{pname}-%1-firstboot; \
fi;  

%define postunscript()  \
if [ "$1" = "0" ] ; then \
 if [ -d %{configdir}/%{pname}-%1 ]; then \
   rm -rf %{configdir}/%{pname}-%1; \
 fi; \
 if [ -d %{logdir}/%{pname}-%1 ]; then  \
   rm -rf %{logdir}/%{pname}-%1; \
 fi; \
fi;  

%pre 
%{expand:%%prescript %{dbrel}}

%preun
%{expand:%%preunscript %{dbrel}}

%posttrans
%{expand:%%posttransscript %{dbrel}}

%postun
%{expand:%%postunscript %{dbrel}}

%files
%defattr(-,root,root)
%config %{configdir}/%{name}/%{name}.param
%ghost /etc/security/limits.d/%{name}.conf
%{configdir}/%{name}
/etc/rc.d/init.d/%{name}-firstboot
%{configdir}/%{name}/%{name}-verify
%{logdir}/%{name}
/usr/bin/%{name}-verify

%changelog
* Thu May 7 2020 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-1.el8]
- BUILDINFO: commit=4c98123f6080dadb15bdade78a6b34829313a7e5
 - Update boot options when grubby is used with blscfg [Orabug: 31316405]

* Mon Apr 27 2020 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-0.4.el8]
 - Do not install on an EXADATA system [Orabug: 31230333]
 - Removed compat-openssl10, compat-libstdc++, compat-libcap1 and added openssl-libs, libnsl [Orabug: 29529333]

* Thu Feb 6 2020 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-0.3.el8]
 - Check if blscfg is set [Orabug: 30860929]

* Mon Jul 29 2019 Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-0.2.el8]
 - Look for exact match in /etc/group [Orabug: 30106011]
 - Fix for picking the next available uid/gid [Orabug: 30108093]
 - Spec made modular 
 - Code moved to git

* Mon May 21 2018  Vasundhara V <vasundhara.venkatasubramanian@oracle.com> [1.0-0.1.el8]
 - Removed OL deps [Orabug 28147536]
 - Initial version
